;Vanocni stromecek - Osvetleni
;Rizeni vnitrnim oscilatorem 4MHz

	LIST P=16F630, R=DEC
	INCLUDE<P16F630.INC>
	__CONFIG 0x3F84

W		EQU	0	;nastaveno pro umisteni vysledku
F		EQU	1	;operaci

;--------promene------------------------
	CBLOCK 0x20
COUNT1
COUNTA
COUNTB
TMP1
TMP2

	ENDC
;---------------------------------------

;--------definice----------------------
#DEFINE	CE		PORTA,0		;Cervena	
#DEFINE	ZE		PORTA,1		;Zelena
#DEFINE	MO		PORTA,2		;Modra
#DEFINE	ZL		PORTA,4		;Zluta
;---------------------------------------

	ORG	00h
	GOTO	START




;--------DELAY 4MHz clock------------	
DELAY1000			;delay 1000 mS (4 MHz clock)
	MOVLW	4
	MOVWF	TMP1
	CALL	DELAY255
	DECFSZ	TMP1,F
	GOTO	$-2
	RETLW	0x00

DELAY500			;delay 500 mS (4 MHz clock)
	MOVLW	2
	MOVWF	TMP1
	CALL	DELAY255
	DECFSZ	TMP1,F
	GOTO	$-2
	RETLW	0x00

DELAY255	
	MOVLW	255		;delay 255 mS (4 MHz clock)
	GOTO	D0

DELAY200	
	MOVLW	150		;delay 200 mS (4 MHz clock)
	GOTO	D0
	
DELAY1
	MOVLW	1		;delay 1.000 ms 

D0		
	MOVWF	COUNT1
D1	
	MOVLW	199		;delay 1mS
	MOVWF	COUNTA
	MOVLW	1
	MOVWF	COUNTB

DELAY_0
	DECFSZ	COUNTA,F
	GOTO	$+2
	DECFSZ	COUNTB,F
	GOTO	DELAY_0

	DECFSZ	COUNT1,F
	GOTO	D1
	RETLW	0x00

;----------------------------------


;*****************************************************
START	
	BANKSEL	PORTA		;Banka 0
	CLRF	PORTA
	MOVLW	07h			;Vypnuti komparatoru
	MOVWF	CMCON		;PortA I/O
	BANKSEL	TRISA		;Banka 1
	MOVLW	B'00001000'
	MOVWF	TRISA
	MOVLW	B'00000000'
	MOVWF	TRISC
	BANKSEL	PORTA		;Banka 0

	CLRF	COUNT1
	CLRF	COUNTA
	CLRF	COUNTB
	CLRF	TMP1
	CLRF	TMP2
	CLRF	PORTA
	CLRF	PORTC



	
MAIN
	NOP
	BSF		ZL			;Rozsviti se zluta
	BSF		CE			;Rozsviti se cervene
	NOP
	MOVLW	B'11111111'
	MOVWF	PORTC
	CALL	DELAY1000
	CALL	DELAY500
	MOVLW	B'00000000'
	MOVWF	PORTC
	BCF		CE			;Zhasne cervena
	BCF		ZL			;Zhasne zluta
	
	CALL	DELAY1000
	BSF		ZL			;Rozsviti se zluta
	BSF		ZE			;Rozsviti se zelena
	NOP
	MOVLW	B'11111111'
	MOVWF	PORTC
	CALL	DELAY1000
	CALL	DELAY500
	MOVLW	B'00000000'
	MOVWF	PORTC
	BCF		ZE			;Zhasne zelena
	BCF		ZL			;Zhasne zluta
	
	CALL	DELAY1000
	BSF		ZL			;Rozsviti se zluta
	BSF		MO			;Rozsviti se modra
	NOP
	MOVLW	B'11111111'
	MOVWF	PORTC
	CALL	DELAY1000
	CALL	DELAY500
	MOVLW	B'00000000'
	MOVWF	PORTC
	BCF		MO			;Zhasne modra
	BCF		ZL			;Zhasne zluta
;Efekt rotace
	CALL	DELAY1000
	BSF		CE			;Rozsviti se cervene
	CALL	ROTACE
	BCF		CE			;Zhasne cervene
	
	CALL	DELAY1000
	BSF		ZE			;Rozsviti se zelene
	CALL	ROTACE
	BCF		ZE			;Zhasne zelene

	CALL	DELAY1000
	BSF		MO			;Rozsviti se modre
	CALL	ROTACE
	BCF		MO			;Zhasne modre	
	CALL	DELAY500
	
;Efekt mna barev
	CALL	DELAY1000
	BSF		ZL			;Rozsviti se zluta
	MOVLW	B'00111111'
	MOVWF	PORTC
	MOVLW	245
	MOVWF	TMP2
	
EF2
	BSF		CE			;Rozsviti se cervene
	CALL	DELAY255
	BCF		CE
	CALL	DELAY1
	BSF		ZE			;Rozsviti se zelena
	CALL	DELAY255
	BCF		ZE
	CALL	DELAY1
	BSF		MO			;Rozsviti se modra
	CALL	DELAY255
	BCF		MO
	CALL	DELAY1
	INCFSZ	TMP2,F
	GOTO	EF2
	BCF		ZL			;Zhasne zluta
	MOVLW	B'00000000'
	MOVWF	PORTC
	CALL	DELAY1000
	CALL	DELAY500
	
	GOTO	MAIN
	
;-----------Pomocn programy---------

ROTACE
	MOVLW	B'00000001'	;Rotace vpravo 
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00000011'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00000111'
	MOVWF	PORTC
	CALL	DELAY500
	BSF		ZL
	CALL	DELAY500
	MOVLW	B'00001111'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00011111'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00111111'
	MOVWF	PORTC
	CALL	DELAY500


	CALL	DELAY1000	;Rotace vlevo
	MOVLW	B'00011111'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00001111'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00000111'
	MOVWF	PORTC
	CALL	DELAY500
	BCF		ZL
	CALL	DELAY500
	MOVLW	B'00000011'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00000001'
	MOVWF	PORTC
	CALL	DELAY500
	MOVLW	B'00000000'
	MOVWF	PORTC
	CALL	DELAY500
	RETLW	0x00
		
	END
